<?php
///ipblocker Component//
/**
* Content code
* @package ipblocker
* @Copyright (C) 2005 Rene Kreijveld
* @ All rights reserved
* @ ipblocker is Free Software
* @ Released under GNU/GPL License : http://www.gnu.org/copyleft/gpl.html
* @version 1.1
**/

// ensure this file is being included by a parent file
defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

// ensure user has access to this function
if (!($acl->acl_check( 'administration', 'edit', 'users', $my->usertype, 'components', 'all' )
		| $acl->acl_check( 'administration', 'edit', 'users', $my->usertype, 'components', 'com_newsfeeds' ))) {
	mosRedirect( 'index2.php', _NOT_AUTH );
}

require_once( $mainframe->getPath( 'admin_html' ) );
require_once( $mainframe->getPath( 'class' ) );

$task = mosGetParam( $_REQUEST, 'task', array(0) );

switch ($task) {

	case "publish":
		publishIPBlocker( $id, 1, $option );
		break;

	case "unpublish":
		publishIPBlocker( $id, 0, $option );
		break;

	case "new":
		editIPBlocker( 0, $option );
		break;
 
	case "edit":
		editIPBlocker( $id[0], $option );
		break;
 
	case "remove":
		removeIPBlocker( $id, $option );
		break;

	case "save":
		saveIPBlocker( $option );
		break;
		
	case "cancel":
		cancelIPBlocker( $option );
		break;

	default:
		showIPBlocker( $option );
		break;
}

/**
* Publishes or Unpublishes one or more modules
* @param array An array of unique category id numbers
* @param integer 0 if unpublishing, 1 if publishing
* @param string The current GET/POST option
*/
function publishIPBlocker( $cid, $publish, $option ) {
	global $database;

	if (count( $cid ) < 1) {
		$action = $publish ? 'publish' : 'unpublish';
		echo "<script> alert('Select a item to ".$action."'); window.history.go(-1);</script>\n";
		exit;
	}

	$cids = implode( ',', $cid );

	$database->setQuery( "UPDATE #__ipblocker SET published=($publish) WHERE id IN ($cids)");
	if (!$database->query()) {
		echo "<script> alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";
		exit();
	}

	if (count( $cid ) == 1) {
		$row = new mosIPBlocker( $database );
		$row->checkin( $cid[0] );
	}

	mosRedirect( "index2.php?option=$option" );
}

/**
* Creates a new or edits and existing user record
* @param int The id of the user, 0 if a new entry
* @param string The current GET/POST option
*/
function editIPBlocker( $cid, $option ) {
	global $database;
	$row = new mosIPBlocker( $database );
	$row->load( $cid );
  
	HTML_ipblocker::editIPBlocker( $row, $option );
}

/**
* Removes records
* @param array An array of id keys to remove
* @param string The current GET/POST option
*/
function removeIPBlocker( $cid, $option ) {
	global $database;

	if (!is_array( $cid ) || count( $cid ) < 1) {
		echo "<script> alert('Select an item to delete'); window.history.go(-1);</script>\n";
		exit;
	}
	
	$cids = implode( ',', $cid );
	$database->setQuery( "DELETE FROM #__ipblocker WHERE id IN ($cids)" );
	if (!$database->query()) {
		echo "<script> alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";
	}
	
	mosRedirect( "index2.php?option=$option" );
}

/**
* Saves the record from an edit form submit
* @param string The current GET/POST option
*/
function saveIPBlocker( $option ) {
	global $database;
	$row = new mosIPBlocker( $database );

	if (!$row->bind( $_POST )) {
		echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
		exit();
	}

	if (!$row->store()) {
		echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
		exit();
	}

	mosRedirect( "index2.php?option=$option" );
}

/**
* Cancels an edit operation
* @param string The current GET/POST option
*/
function cancelIPBlocker( $option ) {
	global $database;

	$row = new mosIPBlocker( $database );
	$row->bind( $_POST );
	$row->checkin();
	mosRedirect( "index2.php?option=$option" );
}

/**
* List the records
* @param string The current GET/POST option
*/
function showIPBlocker($option) {
	global $database, $mainframe;

	$limit = $mainframe->getUserStateFromRequest( "viewlistlimit", 'limit', 10 );
	$limitstart = $mainframe->getUserStateFromRequest( "view{$option}limitstart", 'limitstart', 0 );

	// get the total number of records
	$database->setQuery( "SELECT count(*) FROM #__ipblocker" );

	$total = $database->loadResult();
	echo $database->getErrorMsg();

	require_once("includes/pageNavigation.php");
	$pageNav = new mosPageNav( $total, $limitstart, $limit );

	# Do the main database query
	$database->setQuery( "SELECT * FROM #__ipblocker ORDER BY id LIMIT $pageNav->limitstart,$pageNav->limit" );
	$rows = $database->loadObjectList();
	if ($database->getErrorNum()) {
		echo $database->stderr();
		return false;
	}
  
	HTML_ipblocker::showIPBlocker( $rows, $pageNav, $option );
}
?>